MantisBT
Mantis Bug Tracker Workflow

View Issue Details Jump to Notes ] Related Changesets ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0021727Open CASCADE[OCCT] OCCT:Modeling Algorithmspublic2010-05-05 19:052015-05-14 16:23
Reporterabv 
Assigned Tobugmaster 
PrioritynormalSeveritytrivial 
StatusclosedResolutionfixed 
PlatformOSAllOS Version
Product Version 
Target Version[OCCT] 6.9.0Fixed in Version[OCCT] 6.9.0 
Summary0021727: BRepBuilderAPI_Copy (and possibly other similar tools) create new shape in Frozen state
DescriptionTools like BREpBuilderAPI_Copy create a new shape which should be free; however
they produce shape in frozen state. Try the following commands in DRAW:

=========================

Draw[0]> pload MODELING
Draw[1]> box b 10 10 10
Draw[2]> whatis b
b is a shape SOLID FORWARD Free Modified
Draw[3]> compound b c
Draw[4]> whatis b
b is a shape SOLID FORWARD Modified
Draw[5]> tcopy b q
q
Draw[6]> whatis q
q is a shape SOLID FORWARD Modified

=============================

Note that shape b looses flag Free when it is added to compound; however q is
new shape and should be Free
Steps To Reproducepload MODELING
box b 10 10 10
whatis b
compound b c
whatis b
tcopy b q
whatis q
TagsNo tags attached.
Test case numberbugs modalg_6(011) bug21727
Attached Files

- Relationships

-  Notes
(0033298)
san (developer)
2014-10-17 20:21

This issue is no longer blocking for #25132, so correction is postponed to later release, also because the solution is not obvious.
(0039821)
git (administrator)
2015-04-16 11:10

Branch CR21727 has been created by ink.

SHA-1: e9c0c6103649f4f0711caa1d0b2ad04653652973


Detailed log of new commits:

Author: ink
Date: Thu Apr 16 11:09:26 2015 +0300

    0021727: BRepBuilderAPI_Copy (and possibly other similar tools) create new shape in Frozen state
    
    Set the value of flag Frozen to false for shape created in BRepBuilderAPI_ModifyShape::DoModif().
(0039848)
msv (developer)
2015-04-16 12:48

It is not safe to reset Free flag in DoModif method, because myModifier can leave an old shape without creation of a new one.
The better place to make the fix is in the file BRepTools_Modifier.cxx:547:

  result.Free (S.Free());

I propose to remove this line. If 'result' was got by EmptyCopied method the flag Free is always false. If 'result' is just a subshape that will be placed in a shape of upper level then the flag Free will be set when it is added to the parent shape. So, there is no necessity to set the flag Free directly.
(0039853)
git (administrator)
2015-04-16 13:11

Branch CR21727 has been updated forcibly by ink.

SHA-1: 2bbf2bb9e1e5ef64626d6436a76e0a181690d3ee
(0039855)
msv (developer)
2015-04-16 13:24

Reviewed.
(0039976)
git (administrator)
2015-04-17 16:51

Branch CR21727 has been updated forcibly by apv.

SHA-1: 98d648cceef09fa560899d617c073b335f530700
(0040218)
git (administrator)
2015-04-24 16:37

Branch CR21727 has been updated forcibly by apv.

SHA-1: 81f9b35e17c55ae6321aef122d78476cb13d48ab
(0040219)
apv (tester)
2015-04-24 16:38

Branch CR21727 has been rebased on the current master
(0040362)
git (administrator)
2015-04-28 16:11

Branch CR21727 has been updated by apv.

SHA-1: 934fc04360dc39277e23ffb3b364bde694c9a278


Detailed log of new commits:

Author: apv
Date: Tue Apr 28 16:10:45 2015 +0300

    Test-case for issue 0021727

(0040369)
apv (tester)
2015-04-28 17:23

Dear BugMaster,

Branch CR21727 from occt git-repository (and master from products git-repository) was compiled on Linux, MacOS and Windows platforms and tested.
SHA-1: 81f9b35e17c55ae6321aef122d78476cb13d48ab

Number of compiler warnings:
occt component:
   Linux: 18 (18 on master)
   Windows: 0 (0 on master)
products component:
   Linux: 4 (4 on master)
   Windows: 0 (0 on master)

Regressions/Differences:
Not detected

Testing cases:
bugs modalg_6(011) bug21727 - OK
http://occt-tests/CR21727-master-occt-64/Debian60-64/bugs/modalg_6/bug21727.html [^]
http://occt-tests/CR21727-master-occt-64/Windows-64-VC10/bugs/modalg_6/bug21727.html [^]

Testing on Linux:
Total MEMORY difference: 94754087 / 94536502 [+0.23%]
Total CPU difference: 54117.7799999996 / 51016.899999999456 [+6.08%]

Testing on Windows:
Total MEMORY difference: 57633079 / 57268183 [+0.64%]
Total CPU difference: 16362.492487098909 / 15811.13815279897 [+3.49%]
(0040919)
git (administrator)
2015-05-14 16:23

Branch CR21727 has been deleted by inv.

SHA-1: 934fc04360dc39277e23ffb3b364bde694c9a278

- Related Changesets
occt: master 062d7dfd
Timestamp: 2015-04-30 11:09:32
Author: ink
Committer: bugmaster
Details ] Diff ]
0021727: BRepBuilderAPI_Copy (and possibly other similar tools) create new shape in Frozen state

Set the value of flag Frozen to false for shape created in BRepTools_Modifier. If shape is not newly created then value of flag Frozen don't changed.

Test-case for issue 0021727
mod - src/BRepTools/BRepTools_Modifier.cxx Diff ] File ]
add - tests/bugs/modalg_6/bug21727 Diff ] File ]

- Issue History
Date Modified Username Field Change
2010-05-13 16:18 bugmaster Assigned To bugmaster => abv
2010-05-13 16:18 bugmaster Status new => assigned
2011-08-02 11:31 bugmaster Category OCCT:MOA => OCCT:Modeling Algorithms
2014-08-21 14:29 abv Assigned To abv => san
2014-08-21 14:29 abv Fixed in Version EMPTY =>
2014-08-21 14:29 abv Target Version => 6.8.0
2014-08-21 14:29 abv Description Updated View Revisions
2014-08-21 19:43 san Relationship added related to 0025132
2014-10-17 20:21 san Note Added: 0033298
2014-10-17 20:21 san Assigned To san => abv
2014-10-17 20:21 san Target Version 6.8.0 => 7.1.0
2015-04-16 06:44 abv Assigned To abv => ink
2015-04-16 11:10 git Note Added: 0039821
2015-04-16 11:14 ink Assigned To ink => msv
2015-04-16 11:14 ink Status assigned => resolved
2015-04-16 11:14 ink Steps to Reproduce Updated View Revisions
2015-04-16 12:48 msv Note Added: 0039848
2015-04-16 12:48 msv Assigned To msv => ink
2015-04-16 12:48 msv Status resolved => assigned
2015-04-16 13:11 git Note Added: 0039853
2015-04-16 13:12 ink Assigned To ink => msv
2015-04-16 13:12 ink Status assigned => resolved
2015-04-16 13:24 msv Note Added: 0039855
2015-04-16 13:24 msv Assigned To msv => bugmaster
2015-04-16 13:24 msv Status resolved => reviewed
2015-04-17 15:32 apv Assigned To bugmaster => apv
2015-04-17 16:51 git Note Added: 0039976
2015-04-24 16:37 git Note Added: 0040218
2015-04-24 16:38 apv Note Added: 0040219
2015-04-28 16:11 git Note Added: 0040362
2015-04-28 16:11 apv Test case number => bugs modalg_6(011) bug21727
2015-04-28 17:23 apv Note Added: 0040369
2015-04-28 17:23 apv Assigned To apv => bugmaster
2015-04-28 17:23 apv Status reviewed => tested
2015-05-07 11:18 bugmaster Changeset attached => occt master 062d7dfd
2015-05-07 11:18 bugmaster Status tested => verified
2015-05-07 11:18 bugmaster Resolution open => fixed
2015-05-07 11:34 bugmaster Target Version 7.1.0 => 6.9.0
2015-05-14 15:28 aiv Status verified => closed
2015-05-14 15:30 aiv Fixed in Version => 6.9.0
2015-05-14 16:23 git Note Added: 0040919


Copyright © 2000 - 2020 MantisBT Team
Powered by Mantis Bugtracker